USE MeineTestDB
GO

CREATE TABLE Bestand(Kuerzel varchar(10) PRIMARY KEY, Menge int CHECK (Menge > 0))
CREATE TABLE Handel(Kuerzel varchar(10) PRIMARY KEY, Veraenderung int CHECK (Veraenderung <> 0))
GO

INSERT INTO Bestand VALUES ('ADVW', 10)
INSERT INTO Bestand VALUES ('BYA', 5)

INSERT INTO Handel VALUES('ADVW', 5)
INSERT INTO Handel VALUES('BYA', -5)
INSERT INTO Handel VALUES('NWT', 3)

SELECT * FROM Bestand
SELECT * FROM Handel

MERGE Bestand
 USING Handel
 ON Bestand.Kuerzel = Handel.Kuerzel
 WHEN MATCHED AND (Bestand.Menge + Handel.Veraenderung = 0) THEN
   -- lschen, falls der komplette Bestand verkauft wurde
   DELETE
 WHEN MATCHED THEN
   -- Bestand updaten (nachdem ein mgliches Delete durchgefhrt wurde)
   UPDATE SET Bestand.Menge += Handel.Veraenderung
 WHEN NOT MATCHED BY TARGET THEN
   -- Neukufe hinzufgen
  INSERT VALUES (Handel.Kuerzel, Handel.Veraenderung);

SELECT * FROM Bestand
SELECT * FROM Handel

-- Aufrumen
DROP TABLE Bestand
DROP TABLE Handel